{
Author:  Prof1983: <prof1983@yandex.ru>
Created: 28.05.2011
LastMod: 28.05.2011
}
unit TestUnit5;

interface

uses
  Windows,
  TestCallData, TestCall_TLB, TestUnit3;

function TestInterfaceCdecl: Integer;
function TestInterfaceCdeclTimer: Integer;
function TestInterfaceDispatch: Integer;
function TestInterfaceFastcall: Integer;
function TestInterfaceFastcallTimer: Integer;
function TestInterfaceSafecall: Integer;
function TestInterfaceSafecallTimer: Integer;
function TestInterfaceStdcall: Integer;
function TestInterfaceStdcallTimer: Integer;

implementation

function TestInterfaceCdecl: Integer;
var
  I: Integer;
  O: IInterface1;
  T1: DWORD;
  T2: DWORD;
begin
  T1 := GetTickCount();
  O := TObject1.Create();
  for I := 0 to COUNT_I do
    O.Func(1, 2);
  O := nil;
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestInterfaceCdeclTimer: Integer;
var
  O: IInterface1;
begin
  O := TObject1.Create();
  FStopping := False;
  Result := 0;
  while not(FStopping) do
  begin
    O.Func(1, 2);
    Inc(Result);
  end;
  O := nil;
end;

function TestInterfaceDispatch: Integer;
var
  I: Integer;
  O: Iaaa;
  T1: DWORD;
  T2: DWORD;
begin
  T1 := GetTickCount();
  O := Coaaa.Create();
  for I := 0 to COUNT_I do
    O.Method1(1, 2);
  O := nil;
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestInterfaceFastcall: Integer;
var
  I: Integer;
  O: IInterface0;
  T1: DWORD;
  T2: DWORD;
begin
  T1 := GetTickCount();
  O := TObject0.Create();
  for I := 0 to COUNT_I do
    O.Func(1, 2);
  O := nil;
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestInterfaceFastcallTimer: Integer;
var
  O: IInterface0;
begin
  O := TObject0.Create();
  FStopping := False;
  Result := 0;
  while not(FStopping) do
  begin
    O.Func(1, 2);
    Inc(Result);
  end;
  O := nil;
end;

function TestInterfaceSafecall: Integer;
var
  I: Integer;
  O: IInterface3;
  T1: DWORD;
  T2: DWORD;
begin
  T1 := GetTickCount();
  O := TObject3.Create();
  for I := 0 to COUNT_I do
    O.Func(1, 2);
  O := nil;
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestInterfaceSafecallTimer: Integer;
var
  O: IInterface3;
begin
  O := TObject3.Create();
  FStopping := False;
  Result := 0;
  while not(FStopping) do
  begin
    O.Func(1, 2);
    Inc(Result);
  end;
  O := nil;
end;

function TestInterfaceStdcall: Integer;
var
  I: Integer;
  O: IInterface2;
  T1: DWORD;
  T2: DWORD;
begin
  T1 := GetTickCount();
  O := TObject2.Create();
  for I := 0 to COUNT_I do
    O.Func(1, 2);
  O := nil;
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestInterfaceStdcallTimer: Integer;
var
  O: IInterface2;
begin
  O := TObject2.Create();
  FStopping := False;
  Result := 0;
  while not(FStopping) do
  begin
    O.Func(1, 2);
    Inc(Result);
  end;
  O := nil;
end;

end.
