{
Author:  Prof1983: <prof1983@yandex.ru>
Created: 28.05.2011
LastMod: 29.05.2011
}
unit TestProcLong;

interface

uses
  Windows,
  TestCallData, TestUnit2;

function TestProcLongCdecl: Integer;
function TestProcLongFastcall: Integer;
function TestProcLongSafecall: Integer;
function TestProcLongStdcall: Integer;

implementation

function TestProcLongCdecl: Integer;
var
  I: Integer;
  T1: DWORD;
  T2: DWORD;
begin
  ProcLongCdecl(1, 2);
  T1 := GetTickCount();
  for I := 0 to COUNT_I do
    ProcLongCdecl(1, 2);
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestProcLongFastcall: Integer;
var
  I: Integer;
  T1: DWORD;
  T2: DWORD;
begin
  ProcLongFastcall(1, 2);
  T1 := GetTickCount();
  for I := 0 to COUNT_I do
    ProcLongFastcall(1, 2);
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestProcLongSafecall: Integer;
var
  I: Integer;
  T1: DWORD;
  T2: DWORD;
begin
  ProcLongSafecall(1, 2);
  T1 := GetTickCount();
  for I := 0 to COUNT_I do
    ProcLongSafecall(1, 2);
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestProcLongStdcall: Integer;
var
  I: Integer;
  T1: DWORD;
  T2: DWORD;
begin
  ProcLongStdcall(1, 2);
  T1 := GetTickCount();
  for I := 0 to COUNT_I do
    ProcLongStdcall(1, 2);
  T2 := GetTickCount();
  Result := T2 - T1;
end;

end.
 